
// to represent an author of a book
class Author implements ISame{
	public String name;
	public int year;
	public ALoB books;
	
	public Author(String name, int year){
		this.name = name;
		this.year = year;
		this.books = new MTLoB();
	}
	
	// add the given book to this author's list of books
	public void addBook(Book b){
		this.books = new ConsLoB(b, this.books);
	}	  
	
	// count the number of books written by this author
	public int countBooks(){
		return this.books.count();
	}

        // is this author's name the same as the given one
	public boolean sameName(String name){
		return this.name.equals(name);
	}
	
  	// determine extensional equality of this and given object
  	public boolean same(Object obj){
    		return this.name.equals(((Author)obj).name)
        	    && this.books.sameTitles(((Author)obj).books)
		    && this.year == ((Author)obj).year;
  	}

        // provide the values of this instance represented as a String
	public String toString(){
		return "\n Author: " + 
		       "\n name: "  + this.name +
		       "\n year: "  + this.year + "\n" +
		       "\n books: " + this.books.titleString();
	}
	
	/* Template
	 * 
 	 *   ... this.name ...
     	 *   ... this.year ...
    	 *   ... this.sameName(String name) ...
    	 *   ... this.toString() ...
    	 * 
	 */

}