// to represent a book
class Book implements ISame{
	String	title;
	ALoA 	authors;
	int		year;
	
	public Book(String title, ALoA authors, int year){
		this.title = title;
		this.authors = authors;
		this.year = year;
	        this.authors.addBook(this);
	}
	
        // was this book published before the given year
	public boolean before(int year){
		return this.year < year;
	}
	
	// was this book written by the given author
	public boolean sameAuthor(Author a){
		return this.authors.contains(a);
	}
	
	// count the authros of this book
	public int countAuthors(){
		return this.authors.count();
	}
	
        // determine extensional equality of this and given object
	public boolean same(Object obj){
		return this.title.equals(((Book)obj).title)
		    && this.authors.same(((Book)obj).authors)
		    && this.year == ((Book)obj).year;
	}
	
        // provide the values of this instance represented as a String
	public String toString(){
		return "\n Book: " + 
		       "\n title: "  + this.title +
    	               "\n author: " + this.authors +
		       "\n year: "   + this.year + "\n";
	}
	
	/* Template
	 * 
     	 *   ... this.title ...
     	 *   ... this.author ...
     	 *   ... this.author.sameName(String name) ...
     	 *   ... this.year ...
    	 *   ... this.before(int year) ...
    	 *   ... this.sameAuthor(String name) ...
    	 *   ... this.toString() ...
    	 * 
	 */
}

